package tapl1

import combinatorParsing.{TokenizingParsers, BuildingParsers, Position}

/** This object implements a parser and evaluator for the NB
 *  language of booleans and numbers found in Chapter 3 of
 *  the TAPL book.
 */
object Arithmetic extends TokenizingParsers with BuildingParsers {
  keywords.incl("true", "false", "0", "if", "then", "else", "succ", "pred", "iszero")

  /** <pre>
   *    Expr ::= 'true'
   *           | 'false'
   *           | 'if' Expr 'then' Expr 'else' Expr
   *           | '0'
   *           | 'succ' Expr
   *           | 'pred' Expr
   *           | 'iszero' Expr
   *  </pre>
   */
  def Expr: Parser = production(
      kw("true")
    //to be completed
    | failure("illegal start of expression"))

  type Output = Term

  import implicitConversions._

  /** Build an AST out of the given tokens.
   *
   *  @param xs  The list of tokens.
   *  @param pos ..
   *  @return    ..
   */
  def build(xs: List[Token], pos: Position): Output = xs match {
   //to be completed
    case KW("iszero") :: t :: Nil => IsZero(t)
  }

  def parse(in: String): Option[Output] = 
    output(run(Expr, in))

  //to be completed
}
